From 8ec9f414dee0db37c831b591a17f6e363fedde1e Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Tue, 23 Apr 2019 12:25:03 -0400
Subject: [PATCH 161/161] FIXME: impl-4: initial impl

FIXME: impl-4: implement hash_map of path/state

FIXME: impl-4: run all checkers at once

FIXME: impl-4: work on sm state

FIXME: impl-4: capture exploded_node at warnings

FIXME: impl-4: capture superedges; improve ..dot output

FIXME: impl-4: implement shortest_paths

FIXME: impl-4: start generating diagnostic_paths; fix state transitions

FIXME: impl-4: more on diagnostic_paths, taking material from impl-3

FIXME: impl-4: move diagnostic emission to a subroutine

FIXME: impl-4: state-change events and final events

FIXME: impl-4: add path filtering

FIXME: impl-4: delete some unused checker4_path stuff

FIXME: start adding path_state to program_state

FIXME: impl-4: state-copying in on_assignment; start adding selftests

FIXME: impl-4: update states based on equivalence classes

FIXME: impl-4: add clustering to dot output

FIXME: impl-4: print phi nodes

FIXME: impl-4: call on_assignment for phi nodes

FIXME: impl-4: minor cleanups

FIXME: impl-4: introduce ordered_hash_map and use it for function clusters in .dot dumps

FIXME: impl-4: prune state machines based on flag_analyzer_checker

FIXME: impl-4: print source code in .dot dump

FIXME: impl-4: capture origins of states

FIXME: impl-4: add some stats to graph

FIXME: impl-4: implement hashing/equality for program_state and use it to consolidate nodes

FIXME: impl-4: WIP on pruning state

FIXME: impl-4: add overview

FIXME: impl-4: start adding call strings to program_point

FIXME: impl-4: more on adding call strings to program_point

FIXME: impl-4: hashing fixes

FIXME: impl-4: fix various hacked stack depths

FIXME: impl-4: show stack depth in path_state::to_str

FIXME: differentiate between call vs return superedges in class hierarchy

FIXME: impl-4: copy call string when making program_points

FIXME: impl-4: handle return statements

FIXME: impl-4: more logging

FIXME: impl-4: WIP on interprocedural checking

FIXME: impl-4: reduce the termination cutoff

FIXME: impl-4: update state from caller to callee

FIXME impl-4: fix stack depths in events

FIXME: impl-4: doc fixes

FIXME: impl-4: cluster .dot output by (function, call_string) pairs

FIXME: impl-4: fix call_string::print

FIXME: impl-4: handle recursion more gracefully

FIXME: impl-4: initial impl of leak detection

FIXME: impl-4: introduce class exploded_path

FIXME: impl-4: fix missing decl

FIXME: impl-4: make fields private/const; add m_node_reuse_count; comment fixes; rename m_entrypoint to m_origin

FIXME: impl-4: fixing testsuite failures

FIXME: impl-4: fix location of SUPEREDGE_RETURN events

FIXME: impl-4: fix stmt for state_change_event, to avoid missing events on CFG edges

FIXME: impl-4: exploded_graph::prune_path: prune redundant interprocedural events

FIXME: impl-4: implement COMPONENT_REF in exploded_node::on_stmt

FIXME: change default impl from 2 to 4

FIXME: impl-4: tweaks
---
 gcc/analyzer/Make-lang.in                          |    2 +-
 gcc/analyzer/analyzer-pass.cc                      |    5 +-
 gcc/analyzer/analyzer-plugin.cc                    |    1 +
 gcc/analyzer/analyzer.h                            |    1 +
 gcc/analyzer/constraints.cc                        |  191 +-
 gcc/analyzer/constraints.h                         |   28 +-
 gcc/analyzer/digraph.cc                            |   52 +-
 gcc/analyzer/digraph.h                             |   50 +-
 gcc/analyzer/engine.cc                             |   30 +-
 gcc/analyzer/engine.h                              |    1 +
 gcc/analyzer/exploded-graph.cc                     |   45 -
 gcc/analyzer/exploded-graph.h                      |   59 -
 gcc/analyzer/hardcoded-state-machine.cc            |   19 +-
 gcc/analyzer/hardcoded-state-machine.h             |    2 +
 gcc/analyzer/impl-3.cc                             |   29 +-
 gcc/analyzer/impl-4.cc                             | 4194 ++++++++++++++++++++
 gcc/analyzer/supergraph.cc                         |   54 +-
 gcc/analyzer/supergraph.h                          |   96 +-
 gcc/testsuite/gcc.dg/analyzer/factorial.c          |    7 +
 gcc/testsuite/gcc.dg/analyzer/fibonacci.c          |    7 +
 gcc/testsuite/gcc.dg/analyzer/infinite-recursion.c |   35 +
 gcc/testsuite/gcc.dg/analyzer/loop.c               |    5 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-1.c           |    8 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-ipa-12.c      |    2 +-
 .../gcc.dg/analyzer/malloc-ipa-8-double-free.c     |  119 +-
 .../gcc.dg/analyzer/malloc-ipa-8-unchecked.c       |   21 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-ipa-9.c       |    5 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-paths-5.c     |    2 +-
 gcc/testsuite/gcc.dg/analyzer/params-2.c           |    6 +-
 gcc/testsuite/gcc.dg/analyzer/params.c             |    4 +-
 30 files changed, 4783 insertions(+), 297 deletions(-)
 delete mode 100644 gcc/analyzer/exploded-graph.cc
 delete mode 100644 gcc/analyzer/exploded-graph.h
 create mode 100644 gcc/analyzer/impl-4.cc
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/factorial.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/fibonacci.c

diff --git a/gcc/analyzer/Make-lang.in b/gcc/analyzer/Make-lang.in
index 95c14d8..f742b9d 100644
--- a/gcc/analyzer/Make-lang.in
+++ b/gcc/analyzer/Make-lang.in
@@ -60,7 +60,6 @@ ANALYZER_PLUGIN_SO_OBJS = \
 	analyzer/constraints.o \
 	analyzer/digraph.o \
 	analyzer/engine.o \
-	analyzer/exploded-graph.o \
 	analyzer/graphviz.o \
 	analyzer/hardcoded-state-machine.o \
 	analyzer/hardcoded-state-machine-malloc.o \
@@ -69,6 +68,7 @@ ANALYZER_PLUGIN_SO_OBJS = \
 	analyzer/hardcoded-state-machine-sensitive.o \
 	analyzer/hardcoded-state-machine-taint.o \
 	analyzer/impl-3.o \
+	analyzer/impl-4.o \
 	analyzer/supergraph.o \
 	analyzer/tristate.o \
 
diff --git a/gcc/analyzer/analyzer-pass.cc b/gcc/analyzer/analyzer-pass.cc
index 8417ef1..be676d4 100644
--- a/gcc/analyzer/analyzer-pass.cc
+++ b/gcc/analyzer/analyzer-pass.cc
@@ -84,13 +84,16 @@ pass_analyzer::execute (function *)
 {
   switch (flag_analyzer_impl)
     {
-    default:
     case 2:
       run_checkers_impl_2 ();
       break;
     case 3:
       run_checkers_impl_3 ();
       break;
+    default:
+    case 4:
+      run_checkers_impl_4 ();
+      break;
     }
   return 0;
 }
diff --git a/gcc/analyzer/analyzer-plugin.cc b/gcc/analyzer/analyzer-plugin.cc
index b7b505c..17b69bd 100644
--- a/gcc/analyzer/analyzer-plugin.cc
+++ b/gcc/analyzer/analyzer-plugin.cc
@@ -40,6 +40,7 @@ analyzer_selftests (void */*gcc_data*/, void */*user_data*/)
   analyzer_checker_script_cc_tests ();
   analyzer_constraints_cc_tests ();
   analyzer_engine_cc_tests ();
+  analyzer_impl_4_cc_tests ();
 }
 
 } /* end of namespace selftest.  */
diff --git a/gcc/analyzer/analyzer.h b/gcc/analyzer/analyzer.h
index 72c55df..32a6ab9 100644
--- a/gcc/analyzer/analyzer.h
+++ b/gcc/analyzer/analyzer.h
@@ -53,6 +53,7 @@ namespace selftest {
 extern void analyzer_checker_script_cc_tests ();
 extern void analyzer_constraints_cc_tests ();
 extern void analyzer_engine_cc_tests ();
+extern void analyzer_impl_4_cc_tests ();
 
 } /* end of namespace selftest.  */
 
diff --git a/gcc/analyzer/constraints.cc b/gcc/analyzer/constraints.cc
index 5750c17..249e9de 100644
--- a/gcc/analyzer/constraints.cc
+++ b/gcc/analyzer/constraints.cc
@@ -46,6 +46,8 @@
 std::string
 path_var::to_str () const
 {
+  if (m_tree == NULL_TREE)
+    return "NULL";
   if (CONSTANT_CLASS_P (m_tree))
     return expr_to_string (m_tree);
   else
@@ -115,6 +117,51 @@ equiv_class::to_str () const
 
 /* FIXME.  */
 
+hashval_t
+equiv_class::hash () const
+{
+  inchash::hash hstate;
+  int i;
+  path_var *pv;
+
+  inchash::add_expr (m_constant, hstate);
+  FOR_EACH_VEC_ELT (m_vars, i, pv)
+    inchash::add_path_var (*pv, hstate);
+  hstate.add_flag (m_escaped);
+  hstate.commit_flag ();
+  if (m_extra_state)
+    hstate.merge_hash (m_extra_state->hash ());
+  return hstate.end ();
+}
+
+/* FIXME.  */
+
+bool
+equiv_class::operator== (const equiv_class &other)
+{
+  if (m_constant != other.m_constant)
+    return false; // TODO: use tree equality here
+
+  int i;
+  path_var *pv;
+  FOR_EACH_VEC_ELT (m_vars, i, pv)
+    if (! (*pv == other.m_vars[i]))
+      return false;
+  if (m_escaped != other.m_escaped)
+    return false;
+
+  if ((m_extra_state != NULL) != (other.m_extra_state != NULL))
+    return false;
+
+  if (m_extra_state != NULL)
+    if (!(*m_extra_state == *other.m_extra_state))
+      return false;
+
+  return true;
+}
+
+/* FIXME.  */
+
 void
 equiv_class::add (path_var v)
 {
@@ -264,6 +311,32 @@ constraint::to_str (const path_state &ps) const
 
 /* FIXME.  */
 
+hashval_t
+constraint::hash () const
+{
+  inchash::hash hstate;
+  hstate.add_int (m_lhs.m_idx);
+  hstate.add_int (m_op);
+  hstate.add_int (m_rhs.m_idx);
+  return hstate.end ();
+}
+
+/* FIXME.  */
+
+bool
+constraint::operator== (const constraint &other) const
+{
+  if (m_lhs != other.m_lhs)
+    return false;
+  if (m_op != other.m_op)
+    return false;
+  if (m_rhs != other.m_rhs)
+    return false;
+  return true;
+}
+
+/* FIXME.  */
+
 const equiv_class &
 equiv_class_id::get_obj (const path_state &ps) const
 {
@@ -305,6 +378,71 @@ path_state::~path_state ()
 
 /* FIXME.  */
 
+path_state&
+path_state::operator= (const path_state &other)
+{
+  m_stack_depth = other.m_stack_depth;
+
+  gcc_assert (m_equiv_classes.length () == 0);
+  gcc_assert (m_constraints.length () == 0);
+
+  int i;
+  equiv_class *ec;
+  FOR_EACH_VEC_ELT (other.m_equiv_classes, i, ec)
+    m_equiv_classes.safe_push (new equiv_class (*ec));
+  constraint *c;
+  FOR_EACH_VEC_ELT (other.m_constraints, i, c)
+    m_constraints.safe_push (*c);
+
+  return *this;
+}
+
+/* FIXME.  */
+
+hashval_t
+path_state::hash () const
+{
+  inchash::hash hstate;
+  int i;
+  equiv_class *ec;
+  constraint *c;
+
+  hstate.add_int (m_stack_depth);
+  FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
+    hstate.merge_hash (ec->hash ());
+  FOR_EACH_VEC_ELT (m_constraints, i, c)
+    hstate.merge_hash (c->hash ());
+  return hstate.end ();
+}
+
+/* FIXME.  */
+
+bool
+path_state::operator== (const path_state &other) const
+{
+  if (m_stack_depth != other.m_stack_depth)
+    return false;
+  if (m_equiv_classes.length () != other.m_equiv_classes.length ())
+    return false;
+
+  int i;
+  equiv_class *ec;
+
+  FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
+    if (!(*ec == *other.m_equiv_classes[i]))
+      return false;
+
+  constraint *c;
+
+  FOR_EACH_VEC_ELT (m_constraints, i, c)
+    if (!(*c == other.m_constraints[i]))
+      return false;
+
+  return true;
+}
+
+/* FIXME.  */
+
 std::string
 path_state::to_str () const
 {
@@ -326,7 +464,8 @@ path_state::to_str () const
 	result += " && ";
       result += c->to_str (*this);
     }
-  result += "}";
+  result += "}@";
+  result += std::to_string (m_stack_depth);
   return result;
 }
 
@@ -362,7 +501,7 @@ path_state::apply_constraints_for_edge (const superedge &edge,
 
   if (edge.m_kind == SUPEREDGE_RETURN)
     // FIXME: use as_a<>
-    return apply_constraints_for_return (*edge.dyn_cast_call_superedge ());
+    return apply_constraints_for_return (*edge.dyn_cast_return_superedge ());
 
   if (last_stmt == NULL)
     return true;
@@ -406,7 +545,7 @@ path_state::apply_constraints_for_call (const call_superedge& edge)
 /* FIXME.  */
 
 bool
-path_state::apply_constraints_for_return (const call_superedge&)
+path_state::apply_constraints_for_return (const return_superedge&)
 {
   pop_stack_frame ();
   return true;
@@ -1071,6 +1210,13 @@ debug (const path_state &ps)
   fprintf (stderr, "%s\n", ps.to_str ().c_str ());
 }
 
+void
+inchash::add_path_var (path_var pv, hash &hstate)
+{
+  inchash::add_expr (pv.m_tree, hstate);
+  hstate.add_int (pv.m_stack_depth);
+}
+
 #if CHECKING_P
 
 namespace selftest {
@@ -1784,6 +1930,44 @@ test_stack_frames ()
   }
 }
 
+/* Check that operator== and hashing works as expected for the
+   various types.  */
+
+static void
+test_equality ()
+{
+  path_var int_42 (build_int_cst (integer_type_node, 42), 0);
+  path_var int_0 (build_int_cst (integer_type_node, 0), 0);
+
+  path_var x (build_decl (UNKNOWN_LOCATION, PARM_DECL,
+			  get_identifier ("x"),
+			  integer_type_node), 0);
+  path_var y (build_decl (UNKNOWN_LOCATION, PARM_DECL,
+			  get_identifier ("y"),
+			  integer_type_node), 0);
+  path_var z (build_decl (UNKNOWN_LOCATION, PARM_DECL,
+			  get_identifier ("z"),
+			  integer_type_node), 0);
+
+  {
+    path_state ps0;
+    path_state ps1;
+
+    ASSERT_EQ (ps0.hash (), ps1.hash ());
+    ASSERT_EQ (ps0, ps1);
+
+    ADD_SAT_CONSTRAINT (ps1, x, EQ_EXPR, y);
+    ASSERT_NE (ps0.hash (), ps1.hash ());
+    ASSERT_NE (ps0, ps1);
+
+    path_state ps2;
+    /* Make the same change to ps2.  */
+    ADD_SAT_CONSTRAINT (ps2, x, EQ_EXPR, y);
+    ASSERT_EQ (ps1.hash (), ps2.hash ());
+    ASSERT_EQ (ps1, ps2);
+  }
+}
+
 /* Run all of the selftests within this file.  */
 
 void
@@ -1795,6 +1979,7 @@ analyzer_constraints_cc_tests ()
   test_constraint_impl ();
   test_assignment ();
   test_stack_frames ();
+  test_equality ();
 }
 
 } // namespace selftest
diff --git a/gcc/analyzer/constraints.h b/gcc/analyzer/constraints.h
index b8ef4ed..40243d0 100644
--- a/gcc/analyzer/constraints.h
+++ b/gcc/analyzer/constraints.h
@@ -23,6 +23,7 @@ along with GCC; see the file COPYING3.  If not see
 
 class superedge;
 class call_superedge;
+class return_superedge;
 
 /* One of the end-points of a range.  */
 
@@ -88,6 +89,8 @@ class extra_ec_state
   virtual ~extra_ec_state () {}
   virtual extra_ec_state *clone () const = 0;
   virtual std::string to_str () const = 0;
+  virtual hashval_t hash () const = 0;
+  virtual bool operator== (const extra_ec_state &other) const = 0;
 };
 
 /* FIXME.  */
@@ -100,6 +103,8 @@ public:
   ~equiv_class ();
 
   std::string to_str () const;
+  hashval_t hash () const;
+  bool operator== (const equiv_class &other);
 
   void add (path_var v);
   bool del (path_var v);
@@ -167,6 +172,8 @@ class constraint {
     : m_lhs (lhs), m_op (c_op), m_rhs (rhs) {}
 
   std::string to_str (const path_state &ps) const;
+  hashval_t hash () const;
+  bool operator== (const constraint &other) const;
 
   /* Is this an ordering, rather than a "!=".  */
   bool is_ordering_p () const
@@ -189,6 +196,15 @@ public:
   path_state (const path_state &other);
   ~path_state ();
 
+  path_state& operator= (const path_state &other);
+
+  hashval_t hash () const;
+  bool operator== (const path_state &other) const;
+  bool operator!= (const path_state &other) const
+  {
+    return !(*this == other);
+  }
+
   std::string to_str () const;
 
   const equiv_class &get_equiv_class_by_index (unsigned idx) const
@@ -200,6 +216,12 @@ public:
     return *m_equiv_classes[idx];
   }
 
+  equiv_class &get_equiv_class (path_var pv)
+  {
+    equiv_class_id ec_id = get_or_add_equiv_class (pv);
+    return ec_id.get_obj (*this);
+  }
+
   path_var make_path_var (tree expr) const
   {
     return path_var (expr, m_stack_depth);
@@ -219,7 +241,7 @@ public:
   //private:
   bool apply_constraints_for_call (const call_superedge& edge);
 
-  bool apply_constraints_for_return (const call_superedge& edge);
+  bool apply_constraints_for_return (const return_superedge& edge);
 
   void pop_stack_frame ();
 
@@ -249,5 +271,9 @@ public:
 				equiv_class_id rhs_id);
 };
 
+namespace inchash
+{
+  extern void add_path_var (path_var pv, hash &hstate);
+} // namespace inchash
 
 #endif /* GCC_ANALYZER_CONSTRAINTS_H */
diff --git a/gcc/analyzer/digraph.cc b/gcc/analyzer/digraph.cc
index 09218f3..d03fd6b 100644
--- a/gcc/analyzer/digraph.cc
+++ b/gcc/analyzer/digraph.cc
@@ -51,14 +51,18 @@ along with GCC; see the file COPYING3.  If not see
 #include "digraph.h"
 
 void
-digraph::dump_dot_to_pp (pretty_printer *pp) const
+digraph::dump_dot_to_pp (pretty_printer *pp, cluster *root_cluster) const
 {
+  graphviz_out gv (pp);
+
   pp_string (pp, "digraph \"");
   pp_write_text_to_stream (pp);
   pp_string (pp, "FIXME: base");
   pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
   pp_string (pp, "\" {\n");
 
+  gv.indent ();
+
   pp_string (pp, "overlap=false;\n");
   pp_string (pp, "compound=true;\n");
 
@@ -68,35 +72,61 @@ digraph::dump_dot_to_pp (pretty_printer *pp) const
      https://gcc-python-plugin.readthedocs.io/en/latest/_images/sample-supergraph.png
   */
 
-  /* Nodes.  */
-  int i;
-  dnode *n;
-  FOR_EACH_VEC_ELT (m_nodes, i, n)
-    n->dump_dot ();
+  /* If using clustering, emit all nodes via clusters.  */
+  if (root_cluster)
+    {
+      int i;
+      dnode *n;
+      FOR_EACH_VEC_ELT (m_nodes, i, n)
+	root_cluster->add_node (n);
+      root_cluster->dump_dot (&gv);
+    }
+  else
+    {
+      /* Otherwise, display all nodes at top level.  */
+      int i;
+      dnode *n;
+      FOR_EACH_VEC_ELT (m_nodes, i, n)
+	n->dump_dot (&gv);
+    }
 
   /* Edges.  */
+  int i;
   dedge *e;
   FOR_EACH_VEC_ELT (m_edges, i, e)
-    e->dump_dot ();
+    e->dump_dot (&gv);
 
   /* Terminate "digraph" */
+  gv.outdent ();
   pp_string (pp, "}");
   pp_newline (pp);
 }
 
 void
-digraph::dump_dot_to_file (FILE *fp) const
+digraph::dump_dot_to_file (FILE *fp, cluster *root_cluster) const
 {
   pretty_printer pp;
   pp.buffer->stream = fp;
-  dump_dot_to_pp (&pp);
+  dump_dot_to_pp (&pp, root_cluster);
   pp_flush (&pp);
 }
 
 void
-digraph::dump_dot (const char *path) const
+digraph::dump_dot (const char *path, cluster *root_cluster) const
 {
   FILE *fp = fopen (path, "w");
-  dump_dot_to_file (fp);
+  dump_dot_to_file (fp, root_cluster);
   fclose (fp);
 }
+
+void
+digraph::add_node (dnode *node)
+{
+  m_nodes.safe_push (node);
+}
+
+void
+digraph::add_edge (dedge *edge)
+{
+  m_edges.safe_push (edge);
+}
diff --git a/gcc/analyzer/digraph.h b/gcc/analyzer/digraph.h
index 50f5390..54275d3 100644
--- a/gcc/analyzer/digraph.h
+++ b/gcc/analyzer/digraph.h
@@ -24,36 +24,74 @@ along with GCC; see the file COPYING3.  If not see
 /* Forwards decls.  */
 class dnode;
 class dedge;
+class cluster;
+
+/* Abstract base class for a node in a directed graph.  */
 
 class dnode
 {
  public:
   virtual ~dnode () {}
 
-  virtual void dump_dot () const = 0;
+  virtual void dump_dot (graphviz_out *gv) const = 0;
 };
 
+/* Abstract base class for an edge in a directed graph.  */
+
 class dedge
 {
  public:
   virtual ~dedge () {}
 
-  virtual void dump_dot () const = 0;
+  virtual void dump_dot (graphviz_out *gv) const = 0;
 };
 
+/* Abstract base class for a directed graph.  */
+
 class digraph
 {
  public:
   digraph () {}
   virtual ~digraph () {}
 
-  void dump_dot_to_pp (pretty_printer *pp) const;
-  void dump_dot_to_file (FILE *fp) const;
-  void dump_dot (const char *path) const;
+  void dump_dot_to_pp (pretty_printer *pp, cluster *root_cluster) const;
+  void dump_dot_to_file (FILE *fp, cluster *root_cluster) const;
+  void dump_dot (const char *path, cluster *root_cluster) const;
+
+  void add_node (dnode *node);
+  void add_edge (dedge *edge);
 
- private:
+  //protected:
   auto_delete_vec<dnode> m_nodes;
   auto_delete_vec<dedge> m_edges;
 };
 
+/* Abstract base class for splitting dnodes into hierarchical clusters
+   in the generated .dot file.
+
+   See "Subgraphs and Clusters" within
+     https://www.graphviz.org/doc/info/lang.html
+   and e.g.
+     https://graphviz.gitlab.io/_pages/Gallery/directed/cluster.html
+
+   If a root_cluster is passed to dump_dot*, then all nodes will be
+   added to it at the start of dumping, via calls to add_node.
+
+   The root cluster can organize the nodes into a hierarchy of
+   child clusters.
+
+   After all nodes are added to the root cluster, dump_dot will then
+   be called on it (and not on the nodes themselves).  */
+
+class cluster
+{
+ public:
+  virtual ~cluster () {}
+
+  virtual void add_node (dnode *node) = 0;
+
+  /* Recursively dump the cluster, all nodes, and child clusters.  */
+  virtual void dump_dot (graphviz_out *gv) const = 0;
+};
+
 #endif /* GCC_ANALYZER_DIGRAPH_H */
diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index b549fc8..5281c16 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -41,7 +41,6 @@
 #include "fold-const.h"
 #include "tristate.h"
 #include "selftest.h"
-#include "exploded-graph.h"
 
 ////////////////////////////////////////////////////////////////////////////
 
@@ -811,10 +810,10 @@ public:
     return *m_edge->dyn_cast_cfg_superedge ();
   }
 
-  const call_superedge& get_call_superedge () const
+  const callgraph_superedge& get_callgraph_superedge () const
   {
     gcc_assert (m_edge->m_kind != SUPEREDGE_CFG_EDGE);
-    return *m_edge->dyn_cast_call_superedge ();
+    return *m_edge->dyn_cast_callgraph_superedge ();
   }
 
   checker_event *clone () const FINAL OVERRIDE
@@ -860,7 +859,7 @@ public:
   {
     return sg->get_edge_for_call (m_edge);
   }
-  call_superedge *get_edge_for_return (const supergraph *sg) const
+  return_superedge *get_edge_for_return (const supergraph *sg) const
   {
     return sg->get_edge_for_return (m_edge);
   }
@@ -2398,7 +2397,7 @@ engine::follow_call (sm_instance sm_inst, backtrace b, path_state ps,
 
     if (get_logger ())
       log ("ps before applying return edge: %s", ps.to_str ().c_str ());
-    const call_superedge &return_sedge = *m_sg.get_edge_for_return (edge);
+    const return_superedge &return_sedge = *m_sg.get_edge_for_return (edge);
     ps.apply_constraints_for_return (return_sedge);
     if (get_logger ())
       log ("ps after applying return edge: %s", ps.to_str ().c_str ());
@@ -3271,10 +3270,10 @@ engine::prune_path (checker_path *path,
 
 	      case SUPEREDGE_CALL:
 		{
-		  const call_superedge& call_superedge
-		    = event->get_call_superedge ();
+		  const callgraph_superedge& cg_superedge
+		    = event->get_callgraph_superedge ();
 		  tree caller_var
-		    = call_superedge.map_expr_from_callee_to_caller (var);
+		    = cg_superedge.map_expr_from_callee_to_caller (var);
 		  if (caller_var)
 		    var = caller_var;
 		}
@@ -3283,10 +3282,10 @@ engine::prune_path (checker_path *path,
 		// TODO: potentially update var/state based on return value,
 		// args etc
 		{
-		  const call_superedge& call_superedge
-		    = event->get_call_superedge ();
+		  const callgraph_superedge& cg_superedge
+		    = event->get_callgraph_superedge ();
 		  tree callee_var
-		    = call_superedge.map_expr_from_caller_to_callee (var);
+		    = cg_superedge.map_expr_from_caller_to_callee (var);
 		  if (callee_var)
 		    var = callee_var;
 		}
@@ -3763,15 +3762,6 @@ run_one_checker (const supergraph &sg, const state_machine &sm, logger *logger)
       free (filename);
     }
 
-  if (1)
-    {
-      exploded_graph eg;
-      char *filename
-	= concat (dump_base_name, ".", sm.get_name (), ".eg.dot", NULL);
-      eg.dump_dot (filename);
-      free (filename);
-    }
-
   if (logger)
     {
       log_scope s (logger, "per-node state");
diff --git a/gcc/analyzer/engine.h b/gcc/analyzer/engine.h
index 8f0b1f4..853f1c1 100644
--- a/gcc/analyzer/engine.h
+++ b/gcc/analyzer/engine.h
@@ -1,2 +1,3 @@
 extern void run_checkers_impl_2 ();
 extern void run_checkers_impl_3 ();
+extern void run_checkers_impl_4 ();
diff --git a/gcc/analyzer/hardcoded-state-machine.cc b/gcc/analyzer/hardcoded-state-machine.cc
index fa69b6c..0713d3b 100644
--- a/gcc/analyzer/hardcoded-state-machine.cc
+++ b/gcc/analyzer/hardcoded-state-machine.cc
@@ -142,5 +142,22 @@ make_checkers (auto_delete_vec <state_machine> &out, logger *logger)
   out.safe_push (new fileptr_state_machine (logger));
   out.safe_push (new taint_state_machine (logger));
   out.safe_push (new sensitive_state_machine (logger));
-  // we don't add pattern_test_state_machine by default
+
+  /* We only attempt to run the pattern tests if it might have been manually
+     enabled (for DejaGnu purposes).  */
+  if (flag_analyzer_checker)
+    out.safe_push (new pattern_test_state_machine (logger));
+
+  if (flag_analyzer_checker)
+    {
+      int read_index, write_index;
+      state_machine **sm;
+
+      // FIXME: this leaks the machines
+      // FIXME: would be nice to log the things that were removed
+      VEC_ORDERED_REMOVE_IF (out, read_index, write_index, sm,
+			     0 != strcmp (flag_analyzer_checker,
+					  (*sm)->get_name ()));
+    }
+
 }
diff --git a/gcc/analyzer/hardcoded-state-machine.h b/gcc/analyzer/hardcoded-state-machine.h
index bdc79e0..274c968 100644
--- a/gcc/analyzer/hardcoded-state-machine.h
+++ b/gcc/analyzer/hardcoded-state-machine.h
@@ -48,6 +48,8 @@ public:
   state_machine (const char *name, logger *logger)
   : log_user (logger), m_name (name) {}
 
+  virtual ~state_machine () {}
+
   const char *get_name () const { return m_name; }
 
   const char *get_state_name (state_t s) const;
diff --git a/gcc/analyzer/impl-3.cc b/gcc/analyzer/impl-3.cc
index bfdacb5..30b3240 100644
--- a/gcc/analyzer/impl-3.cc
+++ b/gcc/analyzer/impl-3.cc
@@ -41,7 +41,6 @@
 #include "fold-const.h"
 #include "tristate.h"
 #include "selftest.h"
-#include "exploded-graph.h"
 #include "constraints.h"
 
 namespace impl_3 {
@@ -111,6 +110,18 @@ class ec3_state : public extra_ec_state
 	    + m_sm.get_state_name (m_current_state)
 	    + "')");
   }
+  hashval_t hash () const
+  {
+    // FIXME
+    return (hashval_t)m_baseline_state ^ m_current_state;
+  }
+
+  bool operator== (const extra_ec_state &other) const FINAL OVERRIDE
+  {
+    const ec3_state &other_ec3 = (const ec3_state &)other;
+    return (m_baseline_state == other_ec3.m_baseline_state
+	    && m_current_state == other_ec3.m_current_state);
+  }
 
   const state_machine &m_sm;
 
@@ -445,10 +456,10 @@ public:
     return *m_edge->dyn_cast_cfg_superedge ();
   }
 
-  const call_superedge& get_call_superedge () const
+  const callgraph_superedge& get_callgraph_superedge () const
   {
     gcc_assert (m_edge->m_kind != SUPEREDGE_CFG_EDGE);
-    return *m_edge->dyn_cast_call_superedge ();
+    return *m_edge->dyn_cast_callgraph_superedge ();
   }
 
   checker3_event *clone () const FINAL OVERRIDE
@@ -1405,10 +1416,10 @@ engine::prune_path (checker3_path *path,
 
 	      case SUPEREDGE_CALL:
 		{
-		  const call_superedge& call_superedge
-		    = event->get_call_superedge ();
+		  const callgraph_superedge& cg_superedge
+		    = event->get_callgraph_superedge ();
 		  tree caller_var
-		    = call_superedge.map_expr_from_callee_to_caller (var);
+		    = cg_superedge.map_expr_from_callee_to_caller (var);
 		  if (caller_var)
 		    var = caller_var;
 		}
@@ -1417,10 +1428,10 @@ engine::prune_path (checker3_path *path,
 		// TODO: potentially update var/state based on return value,
 		// args etc
 		{
-		  const call_superedge& call_superedge
-		    = event->get_call_superedge ();
+		  const callgraph_superedge& cg_superedge
+		    = event->get_callgraph_superedge ();
 		  tree callee_var
-		    = call_superedge.map_expr_from_caller_to_callee (var);
+		    = cg_superedge.map_expr_from_caller_to_callee (var);
 		  if (callee_var)
 		    var = callee_var;
 		}
